local harbour = ...

_LightTowerBuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createCircle( 3.3, { 0, 0 }, 16 ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } },
            { Polygon = polygon.createCircle( 3.3, { 0, 0 }, 16 ),
              Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } }
}}
_DockBuildingZone = { ZoneEntryList = {
--            { Polygon = polygon.createRectangle( {16.5, 4.5} ),
--              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } },
            { Polygon = polygon.createRectangle( {16.5, 4.5} ),
              Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } }
}}
_PontonBuildingZone = { ZoneEntryList = {
--            { Polygon = polygon.createRectangle( {6, 4.5} ),
--              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } },
            { Polygon = polygon.createRectangle( {6, 4.5} ),
              Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } }
}}
_RampBuildingZone = { ZoneEntryList = {
--            { Polygon = polygon.createRectangle( {6, 4.5} ),
--              Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } },
            { Polygon = polygon.createRectangle( {6, 4.5} ),
              Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } }
}}
harbour:registerEnumValue ("BUILDING_PART_TYPE", "EXTENSION")
harbour:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")
harbour:registerEnumValue ("BUILDING_PART_TYPE", HarbourPrefix .. "_TERRAIN_NAME")
harbour:registerEnumValue ("BUILDING_PART_TYPE", HarbourPrefix .. "_ENTRANCE_NAME")
harbour:registerEnumValue ("BUILDING_PART_TYPE", HarbourPrefix .. "_WATER_NAME")

-- Register all harbour building parts and their properties

harbour:dofile(_scriptFolder .. "/exportEvent.lua")
harbour:dofile(_scriptFolder .. "/behavior_tree.lua")
harbour:dofile(_scriptFolder .. "/job.lua")
harbour:dofile(_scriptFolder .. "/compStaticBoat.lua")
harbour:dofile(_scriptFolder .. "/compBoat.lua")
harbour:dofile(_scriptFolder .. "/compSail.lua")
harbour:dofile(_scriptFolder .. "/compOar.lua")
harbour:dofile(_scriptFolder .. "/compGuardLocation.lua")
harbour:dofile(_scriptFolder .. "/boat_parts.lua")
harbour:dofile(_scriptFolder .. "/lightTowerB/lighttower_parts.lua", HarbourPrefix, "models/lightTowerB", _scriptFolder .. "/lightTowerB")

-- Register the Harbour monument
harbour:registerAsset({
    Id = HarbourPrefix .. "_VH",
    DataType = "BUILDING",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    AssetMiniatureBuildingPart = HarbourPrefix .. "_BOAT_PART",
    Name = HarbourPrefix .. "_MONUMENT_NAME",
    Description = HarbourPrefix .. "_MONUMENT_DESC",
    BuildingType = "MODS",
    AssetBuildingPartList = {
		            HarbourPrefix .. "_LIGHT_TOWER_ROOT_PART",
		            HarbourPrefix .. "_LIGHT_ROOF_A_PART",
		            CommonWindowPrefix .. "_DECORATION_SFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_LFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_PFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_ARROWSLIT_PART",
		            HarbourPrefix .. "_DOCK_PART",
		            HarbourPrefix .. "_PONTOON_PART",
                        HarbourPrefix .. "_LIGHT_TOWER_PART", -- light tower B

 		            CommonDoorPrefix .. "_ENTRANCE_DOOR_A_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_DOOR_B_PART",
		            HarbourPrefix .. "_RAMP_PART",

		            HarbourPrefix .. "_BOAT_STATIC_PART",
		            HarbourPrefix .. "_BOAT_PART",
		            HarbourPrefix .. "_ROWING_PART",
    },
    MaterialSetList = {
            {
                SetName = HarbourPrefix .. "_RED_ROOF", -- default materials
                MaterialList = {
                    HarbourPrefix .. "_RED_ROOF_MATERIAL"
                }
            },
            {
                SetName = HarbourPrefix .. "_BLUE_ROOF",
                MaterialList = {
                    HarbourPrefix .. "_BLUE_ROOF_MATERIAL"
                }
            },
            {
                SetName = HarbourPrefix .. "_BROWN_ROOF",
                MaterialList = {
                    HarbourPrefix .. "_BROWN_ROOF_MATERIAL"
                }
            },
            {
                SetName = HarbourPrefix .. "_GREY_ROOF",
                MaterialList = {
                    HarbourPrefix .. "_GREY_ROOF_MATERIAL"
                }
            },
            {
                SetName = HarbourPrefix .. "_GREY2_ROOF",
                MaterialList = {
                    HarbourPrefix .. "_GREY2_ROOF_MATERIAL"
                }
            }
    },
    IsManuallyUnlocked = false,
    IsDestructible = true,
    IsEditable = true,
    IsClearTrees = true
})

harbour:registerAsset({
    DataType = "EVENT",
    Id = HarbourPrefix .. "_EVENT_START",
    DaysToFirst = 1,
    ConditionList = {
        {
            DataType = "GAME_CONDITION_BUILDING_BUILT",
            AssetBuilding = "BUILDING_VILLAGE_CENTER",
        },
    },
    ActionList = {
        {
            DataType = "GAME_ACTION_UNLOCK_BUILDING_LIST",
            BuildingProgressData = {
                AssetBuildingList = {
                    HarbourPrefix .. "_VH",
                },
            },
        }
    }
})

harbour:overrideAsset({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND",
        HarbourPrefix .. "_EVENT_START",
    }
})
